Option Explicit
Option Compare Text
DefInt A-Z
'Declares for INI file routines
Global IniFile$
Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any, ByVal lplFileName$)
Declare Function WriteProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any)
Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFilename$)
Declare Function GetProfileString Lib "Kernel" (ByVal lpAppName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Integer) As Integer
Declare Function SetParent Lib "USER.EXE" (ByVal hWndChild As Integer, ByVal hWndParent As Integer) As Integer
Global CRLF$
Declare Function SendMessage& Lib "User" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, lParam As Any)
Global Const WM_USER = &H400
Global Const EM_SETREADONLY = (WM_USER + 31)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Declarations for Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function RegOpenKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName$, lpNewKeyHand&) As Long
Declare Function RegQueryValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName As Any, ByVal lpRes As String, lenResBuff&) As Long
Declare Function RegCloseKey Lib "SHELL.DLL" (lpNewKeyHand&) As Long
Declare Function RegSetValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKey As Any, ByVal fdwType&, ByVal KeyText$, ByVal lenKeyText&) As Long
Declare Function RegEnumKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKeyIndex As Long, ByVal KeyText$, ByVal lenKeyText&) As Long
Global Const REG_SZ = 1
Global Const Error_Success = 0
Global Const HKEY_CLASSES_ROOT = 1

Global ChangeType%
Global ChangedExt$

Sub CenterForm (F As Form)
F.Move (Screen.Width - F.Width) / 2, (Screen.Height - F.Height) / 2
End Sub

Sub CheckRegDB ()
Dim A$, B$, C$, i%, x%, D$, y%
For y% = 0 To 1
    If y% = 0 Then
        A$ = RegListKeys$("", 1)
    Else
        A$ = Trim$(ListPrivateINIEntries("RegDB", "ASSOCMND.INI"))
        For i% = 1 To Len(A$)
            If Mid$(A$, i%, 1) = Chr$(0) Then Mid$(A$, i%, 1) = "|"
        Next
    End If
    If Left$(A$, 1) = "|" Then A$ = Mid$(A$, 2)
    i% = InStr(A$, "|")
    Do While i% > 0
        B$ = Left$(A$, i% - 1)
        If i% + 1 < Len(A$) Then A$ = Mid$(A$, i% + 1):  Else Exit Do
        If Not InStr(B$, "_exe") > 0 Then
            If y% = 0 Then
                Form1.Label2 = "Comparing Registration DB data for " & UCase$(B$) + " to baseline data."
            Else
                Form1.Label2 = "Checking Registration DB for deletions: " & UCase$(B$) + "."
            End If
            x% = DoEvents()
            C$ = RegGetExtDocType$(B$)
            D$ = RegGetExeFromExt$(B$)
            If (y% = 0 And (GetPrivIni$("RegDB", B$, "") <> C$ Or GetPrivIni$("RegDB", B$ & "_exe", "") <> D$)) Or (y% = 1 And Len(C$) = False) Then
                ChangeType% = y%    '0
                ChangedExt$ = B$
                Screen.MousePointer = 0
                Form2.Show 1
                Screen.MousePointer = 11
            End If
        End If
        i% = InStr(A$, "|")
    Loop
Next y%
End Sub

Sub CheckWININI ()
 Dim A$, i%, B$, C$, x%, y%
 For y% = 2 To 3
 If y% = 2 Then
    A$ = Trim$(ListPrivateINIEntries("Extensions", "WIN.INI"))
 Else
    A$ = Trim$(ListPrivateINIEntries("Extensions", IniFile$))
 End If
  i% = InStr(A$, Chr$(0))
  Do While i% > 0
    B$ = Left$(A$, i% - 1)
    If B$ <> "" Then
        
        If y% = 2 Then
            Form1.Label2 = "Comparing WIN.INI [Extensions] data for " & UCase$(B$) + " to baseline data."
        Else
            Form1.Label2 = "Checking WIN.INI for deletions: " & UCase$(B$) + "."
        End If
        x% = DoEvents()
        C$ = GetWINIni$("Extensions", B$, "")
        If (y% = 2 And GetPrivIni$("Extensions", B$, "") <> C$) Or (y% = 3 And Len(C$) = 0) Then
            ChangeType% = y%    '1
            ChangedExt$ = B$
            Screen.MousePointer = 0
            Form2.Show 1
            Screen.MousePointer = 11
        End If
    End If
    A$ = Mid$(A$, i% + 1)
    i% = InStr(A$, Chr$(0))
  Loop
Next y%
End Sub

Function Confirm% (Ask$)
If MsgBox(Ask$, 52, App.Title) = 6 Then Confirm% = True
End Function

Function GetPrivIni$ (pApp$, pKey$, pDefault$)
Dim x%
Dim Ret As String * 1024
x% = GetPrivateProfileString%(pApp$, pKey$, pDefault$, Ret, Len(Ret), IniFile$)
If x% > 0 Then GetPrivIni$ = Left$(Ret, x%)
End Function

Function GetWINIni$ (ByVal pApp$, ByVal Key$, ByVal pDefault$)
Dim x%
Dim Ret As String * 1024
x% = 1024
pDefault$ = ""
x% = GetProfileString(pApp$, Key$, pDefault$, Ret, x%)
If x% > 0 Then GetWINIni$ = Left$(Ret, x%)
End Function

Function ListPrivateINIEntries$ (pApp$, IniFile$)
Dim x%
Dim Ret As String * 4096
x% = GetPrivateProfileString%(pApp$, 0&, "", Ret, Len(Ret), IniFile$)
If x% > 0 Then ListPrivateINIEntries$ = Left$(Ret, x%)
End Function

Sub PutPrivIni (pApp$, pKey$, pString As Variant)
Dim x%, A$, l&

If VarType(pString) = 8 Then
    A$ = pString
    x% = WritePrivateProfileString%(pApp$, pKey$, A$, IniFile$)
Else
    l& = 0&
    x% = WritePrivateProfileString%(pApp$, pKey$, l&, IniFile$)
End If
End Sub

Sub PutWINIni (pApp$, pKey$, pString$)
Dim x%
x% = WriteProfileString%(pApp$, pKey$, pString$)
End Sub

Function RegGetExeFromExt$ (Ext$)
  Dim Buffer$, lb&, exereq$, i%
  Buffer$ = String$(128, 0)
  If Left$(Ext$, 1) <> "." Then Ext$ = "." + Ext$
  lb& = Len(Buffer$)
  If RegQueryValue(HKEY_CLASSES_ROOT, Ext$, Buffer$, lb&) <> Error_Success Then Exit Function
  exereq$ = Left$(Buffer$, InStr(Buffer$, Chr$(0)) - 1) + "\shell\open\command" + Chr$(0)
  Buffer$ = String$(128, 0)
  lb& = Len(Buffer$)
  If RegQueryValue(HKEY_CLASSES_ROOT, exereq$, Buffer$, lb&) <> Error_Success Then Exit Function
  RegGetExeFromExt$ = Buffer$
End Function

Function RegGetExtDocType$ (Ext$)
  Dim Buffer$, lb&, Ret$
  Buffer$ = String$(128, 0)
  If Left$(Ext$, 1) <> "." Then Ext$ = "." + Ext$
  lb& = Len(Buffer$)
  If RegQueryValue(HKEY_CLASSES_ROOT%, Ext$, Buffer$, lb&) <> Error_Success Then Exit Function
  Ret$ = Left$(Buffer$, InStr(Buffer$, Chr$(0)) - 1)
  RegGetExtDocType$ = Ret$
End Function

Function RegListKeys$ (KeyName$, KeyType%)
  Dim NewKey&, i%, Counter&, FoundOne%, lb&, Buffer$, Ret$
  NewKey& = 0
  If RegOpenKey(HKEY_CLASSES_ROOT, KeyName$, NewKey&) <> Error_Success Then GoTo Out
  Buffer$ = String$(128, 0)
  Counter& = 0
  FoundOne% = False
  lb& = Len(Buffer$)
  Do While RegEnumKey&(NewKey&, Counter&, Buffer$, lb&) = 0&
    Select Case KeyType%
    Case 0  'all
      FoundOne% = True
    Case 1  'extensions
      If Left$(Buffer$, 1) = "." Then FoundOne% = True
    Case 2  'others
      If Left$(Buffer$, 1) <> "." Then FoundOne% = True
    End Select
    If FoundOne% Then
      Ret$ = Ret$ + Left$(Buffer$, InStr(Buffer$, Chr$(0)) - 1) + "|"
      FoundOne% = False
    End If
    Counter& = Counter& + 1
  Loop
  i% = RegCloseKey(NewKey&)
Out:
RegListKeys$ = Ret$
End Function

Sub RevertRegDB ()
  Dim i%, A$, B$
  i% = RegSetValue(HKEY_CLASSES_ROOT, ChangedExt$, REG_SZ, GetPrivIni$("RegDB", ChangedExt$, ""), 128)
  Debug.Print i%
End Sub

Sub RevertWINIni ()
Dim B$
B$ = GetPrivIni$("Extensions", ChangedExt$, "")
PutWINIni "Extensions", ChangedExt$, B$
End Sub

Sub SaveNewRegDB ()
'Save changed REGDB data to ASSOC.INI
  Dim A$
  A$ = RegGetExtDocType$(ChangedExt$)
  If Len(A$) Then
    PutPrivIni "RegDB", ChangedExt$, A$
    PutPrivIni "RegDB", ChangedExt$ & "_exe", RegGetExeFromExt$(ChangedExt$)
  Else
    PutPrivIni "RegDB", ChangedExt$, 0&
      PutPrivIni "RegDB", ChangedExt$ & "_exe", 0&
  End If
End Sub

Sub SaveNewWINIni ()
'Save changed WIN.INI data to ASSOC.INI
Dim B1$
B1$ = GetWINIni$("Extensions", ChangedExt$, "")
If Len(B1$) Then
    PutPrivIni "Extensions", ChangedExt$, B1$
Else
    PutPrivIni "Extensions", ChangedExt$, 0&
End If
End Sub

Sub SaveRegDB ()
Dim A$, B$, C$, i%, x%
A$ = RegListKeys$("", 1)
If Left$(A$, 1) = "|" Then A$ = Mid$(A$, 2)
i% = InStr(A$, "|")
Do While i% > 0
    B$ = Left$(A$, i% - 1)
    If i% + 1 < Len(A$) Then A$ = Mid$(A$, i% + 1):  Else Exit Do
    C$ = RegGetExtDocType$(B$)
    PutPrivIni "RegDB", B$, RegGetExtDocType$(B$)
    PutPrivIni "RegDB", B$ & "_exe", RegGetExeFromExt$(B$)
    Form1.Label2 = "Saving Registration DB data for " & UCase$(B$) & "."
    x% = DoEvents()
    i% = InStr(A$, "|")
Loop
End Sub

Sub SaveWININI ()
 Dim A$, i%, B$, x%
  A$ = Trim$(ListPrivateINIEntries("Extensions", "WIN.INI"))
  i% = InStr(A$, Chr$(0))
  Do While i% > 0
    B$ = Left$(A$, i% - 1)
    If B$ <> "" Then
        PutPrivIni "Extensions", B$, GetWINIni$("Extensions", B$, "")
        Form1.Label2 = "Saving WIN.INI Extensions data for " & UCase$(B$) & "."
        x% = DoEvents()
    End If
    A$ = Mid$(A$, i% + 1)
    i% = InStr(A$, Chr$(0))
  Loop
End Sub

