'---------------------------------------------------------------------------
' Visual Basic interface definitions for CPPSUM.DLL
' DLL functions to get summary info from OLE 2.0 document files.
'
'     Copyright (c) 1994 Frank F Ramos, All Rights Reserved
'     Send problem reports and comments to 72202.2574@compuserve.com
'
' Example of usage:
'    Dim wInitStatus as Integer, hSumInfo As Integer, bResult As Integer
'    Dim s$, yr%, mon%, dy%, hr%, min%, sec%
'    wInitStatus = SumInfoInit()
'    If wInitStatus <> 0 Then
'       hSumInfo = SumInfoOpenFile("..put your file name here..")
'       If hSumInfo <> 0 Then
'          s$ = String$(256, " ")
'          bResult = SumInfoGetString(hSumInfo, PID_TITLE, s$, 256)
'          bResult = SumInfoGetTime(hSumInfo, PID_LASTSAVED, yr%, mon%, dy%, hr%, min%, sec%)
'          SumInfoCloseFile (hSumInfo)
'       End If
'       SumInfoUninit(wInitStatus)
'    End If
'
' Reasons for failure:
'     SumInfoInit:     out of memory
'     SumInfoOpenFile: out of memory
'                      file not found
'                      file is not an OLE 2.0 structured storage file
'                      file does not contain OLE 2.0 summary info
'                      OLE 2.0 summary info is incorrectly formatted
'     SumInfoGet...  : specified property type is not available
'
' See CPPSUM.H for change log
'---------------------------------------------------------------------------

   ' String properties
Global Const PID_TITLE = &H2
Global Const PID_SUBJECT = &H3
Global Const PID_AUTHOR = &H4
Global Const PID_KEYWORDS = &H5
Global Const PID_COMMENTS = &H6
Global Const PID_TEMPLATE = &H7
Global Const PID_LASTAUTHOR = &H8
Global Const PID_REVNUMBER = &H9
Global Const PID_APPNAME = &H12

   ' Time properties
Global Const PID_TOTAL_EDITTIME = &HA
Global Const PID_LASTPRINTED = &HB
Global Const PID_CREATED = &HC
Global Const PID_LASTSAVED = &HD

   ' Long integer properties
Global Const PID_PAGECOUNT = &HE
Global Const PID_WORDCOUNT = &HF
Global Const PID_CHARCOUNT = &H10
Global Const PID_SECURITY = &H13

   ' bit masks for security long integer
Global Const AllSecurityFlagsEqNone = &H0
Global Const fSecurityPassworded = &H1
Global Const fSecurityRORecommended = &H2
Global Const fSecurityRO = &H4
Global Const fSecurityLockedForAnnotations = &H8

Declare Function SumInfoInit Lib "CPPSUM.DLL" () As Integer
Declare Function SumInfoOpenFile Lib "CPPSUM.DLL" (ByVal szPath As String) As Integer
Declare Function SumInfoGetString Lib "CPPSUM.DLL" (ByVal hSumInfo As Integer, ByVal pid As Long, ByVal lpBuf As String, ByVal cbBuf As Integer) As Integer
Declare Function SumInfoGetLong Lib "CPPSUM.DLL" (ByVal hSumInfo As Integer, ByVal pid As Long, lpLong As Long) As Integer
Declare Function SumInfoGetTime Lib "CPPSUM.DLL" (ByVal hSumInfo As Integer, ByVal pid As Long, lpYr%, lpMon%, lpDay%, lpHr%, lpMin%, lpSec%) As Integer
Declare Sub SumInfoCloseFile Lib "CPPSUM.DLL" (ByVal hSumInfo As Integer)
Declare Sub SumInfoUninit Lib "CPPSUM.DLL" (ByVal wInitStatus As Integer)


