Option Explicit
DefInt A-Z
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Declarations for ShellExecute
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function ShellExecute Lib "Shell.dll" (ByVal hWnd%, ByVal lpszOp$, ByVal lpszFile$, ByVal lpszParams As Any, ByVal lpszDir$, ByVal fsShowCnd%) As Integer
Declare Function IsIconic Lib "User" (ByVal hWnd%) As Integer
Declare Function ShowWindow Lib "User" (ByVal hWnd%, ByVal nCmdShow%) As Integer
Global Const SW_MAXIMIZE = 3
Global Const SW_RESTORE = 9
Global Const SW_MINIMIZE = 6
Global Const SW_HIDE = 0
Global Const SW_SHOW = 5


'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Declarations for Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Declare Function RegOpenKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName$, lpNewKeyHand&) As Long
Declare Function RegQueryValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName As Any, ByVal lpRes As String, lenResBuff&) As Long
Declare Function RegCloseKey Lib "SHELL.DLL" (lpNewKeyHand&) As Long
Declare Function RegCreateKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal KeyName$, lpNewKeyHand&) As Long
Declare Function RegSetValue Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKey As Any, ByVal fdwType&, ByVal KeyText$, ByVal lenKeyText&) As Long
Declare Function RegEnumKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKeyIndex As Integer, ByVal KeyText$, ByVal lenKeyText&) As Long
Declare Function RegDeleteKey Lib "SHELL.DLL" (ByVal lpOpenKeyHand&, ByVal SubKey As Any) As Long
Const Reg_SZ = 1
Const Error_Success = 0
Const HKEY_Classes_ROOT = 1

Declare Function GetWindowLong& Lib "User" (ByVal hWnd%, ByVal nIndex%)
Declare Function SetWindowLong& Lib "User" (ByVal hWnd%, ByVal nIndex%, ByVal dwNewLong&)
Global Const LBS_NOINTEGRALHEIGHT = &H100&

Sub CenterForm (F As Form)
Dim x%, y%
x% = (screen.Width - F.Width) / 2
y% = (screen.Height - F.Height) / 2
F.Move x%, y%
End Sub

Function CheckReg (Ext$, op%) As Integer
'Form1.GroupPush3D1(op%).Enabled = False
Select Case op%
Case 0
    Form1.Image2(0).Enabled = False
    Form1.Image2(0).Picture = Form1.Image2(3).Picture
Case 1
    Form1.Image3(0).Enabled = False
    Form1.Image3(0).Picture = Form1.Image3(3).Picture
End Select
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Look for print command in Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim x&, NewKey&, KeyName$, y&, Result$
Const lRes& = 80
Result$ = String$(lRes&, 0)
KeyName$ = "." + Ext$
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * Exit if Ext$ not listed in Registration Database
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If RegOpenKey(HKEY_Classes_ROOT, KeyName$, NewKey&) <> Error_Success Then Exit Function
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get Identifier for this key
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
x& = RegQueryValue(NewKey&, 0&, Result$, lRes&)
y& = RegCloseKey(NewKey&)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * exit if no identifier found
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If x& <> Error_Success Then Exit Function
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * get print command
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim o$
Select Case op%
Case 0
    o$ = "\shell\open"
Case 1
    o$ = "\shell\print"
Case 2
    
Case Else
    
End Select
If op% < 2 Then
    Result$ = Left$(Result$, InStr(Result$, Chr$(0)) - 1) + o$
Else
    Result$ = o$
End If
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  * exit if no print command
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
If RegOpenKey(HKEY_Classes_ROOT, Result$, NewKey&) = Error_Success Then
'    If op% < 2 Then
 '       Form1.GroupPush3D1(op%).Enabled = True
Select Case op%
Case 0
    Form1.Image2(0).Enabled = True
    Form1.Image2(0).Picture = Form1.Image2(1).Picture
Case 1
    Form1.Image3(0).Enabled = True
    Form1.Image3(0).Picture = Form1.Image3(1).Picture
'Case 2
'    Exit Function
End Select



'Else Exit Function
End If
'Exit Function 'GoTo Fail
y& = RegCloseKey(NewKey&)
CheckReg = True
End Function

Sub ClearLabels (F As Form, Index%)
Dim i%

For i% = 0 To 14
    If i% <> 12 Then
        If Index% = 1 Then F.Label2(i%) = ""
        If Index% = 2 Then F.Text1(i%) = ""
    End If
Next
F.Text1(0) = ""
F.Text1(1) = ""
End Sub

Function Confirm% (Ask$)
If MsgBox(Ask$, 52, App.Title) = 6 Then Confirm% = True
End Function

Sub DrawTags (F As Form)
F.Label2(0) = "&Title:"
F.Label2(1) = "&Subject:"
F.Label2(2) = "&Application:"
F.Label2(3) = "A&uthor:"
F.Label2(4) = "&Keywords:"
F.Label2(5) = "&Comments:"
F.Label2(6) = "&Template:"
F.Label2(8) = "&Words:"
F.Label2(7) = "C&hars:"
F.Label2(9) = "&Pages:"
F.Label2(10) = "Last saved b&y:"
F.Label2(11) = "&Last Saved:"
F.Label2(13) = "Re&vision #:"
F.Label2(14) = "S&ecurity:"
End Sub

Function ExtractPath (ByVal PathName As String) As String
' Return the directory path portion of a full pathname
    Dim F$, N%
    F$ = PathName
    Do
        N% = InStr(F$, "\")
        If N% > 0 Then F$ = Right$(F$, Len(F$) - N%)
    Loop While N% > 0
    ExtractPath = Left$(PathName, Len(PathName) - Len(F$))
End Function

Sub OutlineTbs (pic_name As PictureBox, ctrl_name As Control, bevel_size As Integer, dn As Integer)
    Dim darkgray As Long, brwhite As Long
    Dim i As Integer, x As Integer, y As Integer, x1 As Integer, y1 As Integer
    Dim col1 As Long, col2 As Long
    'Dim ctrl_name As TextBox
    Dim ctrl_top As Integer, ctrl_left As Integer, ctrl_right As Integer, ctrl_bottom As Integer
    darkgray = &H404040     'RGB(128, 128, 128)
    brwhite = &HFFFFFF      'RGB(255, 255, 255)
    Select Case dn
        Case True
            col1 = brwhite
            col2 = darkgray
        Case False
            col2 = brwhite
            col1 = darkgray
        Case Else
            Exit Sub
    End Select
    
    x1 = screen.TwipsPerPixelX 'twips per pixel horizontally
    y1 = screen.TwipsPerPixelY 'twips per pixel vertically
    bevel_size = bevel_size - 1
For i = 0 To bevel_size Step 1
        x = x1 * i 'distance of horiz. lines from edge
        y = y1 * i 'distance of vert. lines from edge
        ctrl_top = ctrl_name.Top - screen.TwipsPerPixelY
        ctrl_left = ctrl_name.Left - screen.TwipsPerPixelX
        ctrl_right = ctrl_name.Left + ctrl_name.Width
        ctrl_bottom = ctrl_name.Top + ctrl_name.Height
        pic_name.Line (ctrl_left - x, ctrl_bottom + y)-(ctrl_right + x, ctrl_bottom + y), col1
        pic_name.Line (ctrl_right + x, ctrl_top - y)-(ctrl_right + x, ctrl_bottom + y), col1
        pic_name.Line (ctrl_left - x, ctrl_top - y)-(ctrl_right + x, ctrl_top - y), col2
        pic_name.Line (ctrl_left - x, ctrl_top - y)-(ctrl_left - x, ctrl_bottom + y), col2
    Next i
End Sub

