Option Explicit
DefInt A-Z
Type Rect
    Left As Integer
    Top As Integer
    Right As Integer
    Bottom As Integer
End Type
Declare Function BitBlt Lib "GDI" (ByVal hDestDC As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal nWidth As Integer, ByVal nHeight As Integer, ByVal hSrcDC As Integer, ByVal XSrc As Integer, ByVal YSrc As Integer, ByVal dwRop As Long) As Integer
Declare Function DeleteDC Lib "GDI" (ByVal hDC As Integer) As Integer
Declare Function DrawIcon Lib "User" (ByVal hDC As Integer, ByVal x As Integer, ByVal Y As Integer, ByVal hIcon As Integer) As Integer
Type PointAPI
    XPos As Integer
    YPos As Integer
End Type
Declare Sub GetCursorPos Lib "User" (lpPoint As PointAPI)
Declare Sub CopyRect Lib "User" (lpDestRect As Rect, ByVal lpSrc&)
Declare Function UnlockResource Lib "Kernel" Alias "GlobalUnlock" (ByVal hMem As Integer) As Integer
Declare Function CreateDC% Lib "GDI" (ByVal Driver$, ByVal Dev&, ByVal O&, ByVal Init&)
Declare Function GetDeviceCaps% Lib "GDI" (ByVal hDC%, ByVal nIndex%)
Declare Function GetCursor% Lib "User" ()
Declare Function LockResource& Lib "Kernel" (ByVal hRes%)
Global ScreenX, ScreenY
Const SRCCOPY = &HCC0020
Const HORZRES = 8
Const VERTRES = 10
Global Root$
Global Delay%
Global IncludeCursor%
Global Audible%
Global AutoName%
Global PicBoxEmpty%
Global IniFile$

Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any, ByVal lplFileName$)
Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFilename$)

Sub Centerform (F As Form)
F.Left = (Screen.Width - F.Width) / 2
F.Top = (Screen.Height - F.Height) / 2
End Sub

Sub CenterOver (F1 As Form, F2 As Form)
F1.Left = F2.Left + (F2.Width - F1.Width) / 2
F1.Top = F2.Top + (F2.Height - F1.Height) / 2
End Sub

Sub CursorGrab (Pic As PictureBox)
    Dim MousePosX%, hCursor%, lpCursor&, MousePosY%, MyRect As Rect, MyPoint As PointAPI, x%
    GetCursorPos MyPoint 'get cursor hotspot pos
    hCursor% = GetCursor()  'get handle to cursor
    lpCursor& = LockResource&(hCursor%) 'get pointer to resource
    CopyRect MyRect, lpCursor&  'copy first 4 bytes of resource to Rect structure
    x% = UnlockResource(hCursor%) 'release resource
    'first byte (MyRect.Left)=hotspot xpos, 2nd byte (MyRect.Top)
    'is hotspot ypos, so subtract these from values returned by
    'getcursorpos to find x,y of cursor's left,top corner
    MousePosX = MyPoint.XPos - MyRect.Left  'subtract
    MousePosY = MyPoint.YPos - MyRect.Top
    'now draw the cursor there using drawicon function
    x% = DrawIcon(Pic.hDC, MousePosX, MousePosY, hCursor)
End Sub

Function Exists% (F$)
Dim x&
On Error Resume Next
x& = FileLen(F$)
If x& Then Exists% = True
End Function

Function GetPrivIni$ (pApp$, pKey$, pDefault$)
Dim x%
Dim Ret As String * 1024
x% = GetPrivateProfileString%(pApp$, pKey$, pDefault$, Ret, Len(Ret), IniFile$)
If x% > 0 Then GetPrivIni$ = Left$(Ret, x%)
End Function

Sub GetScreenSize ()
    Dim DC%, x%
    DC% = CreateDC("DISPLAY", 0, 0, 0)
    ScreenX% = GetDeviceCaps(DC, HORZRES)
    ScreenY% = GetDeviceCaps(DC, VERTRES)
    x% = DeleteDC(DC)
End Sub

Sub PutPrivIni (pApp$, pKey$, pString As Variant)
Dim x%, A$, l&
If VarType(pString) = 8 Then
    A$ = pString
    x% = WritePrivateProfileString%(pApp$, pKey$, A$, IniFile$)
Else
    l& = 0&
    x% = WritePrivateProfileString%(pApp$, pKey$, l&, IniFile$)
End If
End Sub

Sub ScreenGrab (Pic As PictureBox)
    Dim DC%, x%
    DC% = CreateDC("DISPLAY", 0, 0, 0)
    x% = BitBlt(Pic.hDC, 0, 0, ScreenX, ScreenY, DC%, 0, 0, SRCCOPY)
    x% = DeleteDC(DC%)
End Sub

