Option Explicit
Option Compare Text
Global MoveBasic%
Global TestFont$
Global CRLF$
Global ActiveC As ListBox
Dim ret As String * 24000
'Type Logfont
'  lfHeight As Integer
'  lfWidth As Integer
'  lfEscapement As Integer
'  lfOrientation As Integer
'  lfWeight As Integer
'  lfItalic As String * 1
'  lfUnderline As String * 1
'  lfStrikeOut As String * 1
'  lfCharSet As String * 1
'  lfOutPrecision As String * 1
'  lfClipPrecision As String * 1
'  lfQuality As String * 1
'  lfPitchAndFamily As String * 1
'  lfFaceName As String * 32
'  lfFullName As String * 64
'  lfStyle As String * 32
'End Type
'Declares for INI file routines
Declare Function WritePrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any, ByVal lplFileName$)
Declare Function WriteProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal lpString As Any)
Declare Function GetProfileInt% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName$, ByVal nDefault%)
Declare Function GetPrivateProfileInt% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName$, ByVal nDefault%, ByVal lpFilename$)
Declare Function GetPrivateProfileString% Lib "KERNEL" (ByVal lpApplicationName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%, ByVal lpFilename$)
Declare Function GetProfileString% Lib "KERNEL" (ByVal lpAppName$, ByVal lpKeyName As Any, ByVal lpDefault$, ByVal lpReturnedString$, ByVal nSize%)
Declare Function AddFontResource% Lib "GDI" (ByVal lpFilename As Any)
Declare Function RemoveFontResource% Lib "GDI" (ByVal lpFilename As Any)
Declare Function SendMessage% Lib "USER" (ByVal hWnd%, ByVal wMsg%, ByVal wParam%, lParam As Any)
Const WM_FONTCHANGE = &H1D
Const WM_WININICHANGE = &H1A
'Declares for GetSystemDir
Declare Function GetSystemDirectory Lib "Kernel" (ByVal lpBuffer As String, ByVal nSize As Integer) As Integer

Declare Function EnumFontFamilies% Lib "GDI" (ByVal hDC%, ByVal lpszFamily As Any, ByVal lpFontFonc&, ByVal lpData&)
Declare Sub dwCopyData Lib "DWSPYDLL.DLL" (ByVal Source&, ByVal lpDest As Any, ByVal nCount%)
Global PreviewFontFamily$
Global PreviewFontName$
Global PreviewFontStyle$

Sub Alert (Mess$)
'  * creates an Alert box with an OK button
MsgBox Mess$, 48, App.Title
End Sub

Sub BroadcastIniChange ()
Dim y%
y% = SendMessage(&H0, WM_FONTCHANGE, 0, 0)'tell other apps that font list has changed
y% = SendMessage(&H0, WM_WININICHANGE, 0, 0)'tell other apps that WIN.INI has changed

End Sub

Sub CenterForm (F As Form)
F.Left = (Screen.Width - F.Width) / 2
F.Top = (Screen.Height - F.Height) / 2
End Sub

Sub CheckLimits (Test%)
If Test% = Len(ret) - 2 Then MsgBox "Sorry, but you've installed more fonts than WS Font Manager can handle. WS Font Manager is limited to working with approximately 500 fonts. ": End
End Sub

Sub DeletePrivIni (pApp$, pkey$, pFile$)
Dim X%
X% = WritePrivateProfileString%(pApp$, pkey$, 0&, pFile$)
End Sub

Sub DeleteWinIni (pApp$, pkey$)
Dim X%
X% = WriteProfileString%(pApp$, pkey$, 0&)
End Sub

Function Exists% (F$)
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'  returns 0 if file not found, or if error in file spec,
'  otherwise returns -1
'  * * * * * * * * * * * * * * * * * * * * * * * * * * * *
On Error Resume Next
Exists% = True
If Len(Dir$(F$)) = 0 Then Exists% = False
On Error GoTo 0
End Function

Function FixAPIString$ (ByVal Test$)
FixAPIString$ = Trim(Left$(Test$, InStr(Test$, Chr$(0)) - 1))
End Function

Function GetPrivINI$ (pApp$, pkey$, pDefault$, pFile$)
Dim X%
Dim ret As String * 1024
X% = GetPrivateProfileString%(pApp$, pkey$, pDefault$, ret, Len(ret), pFile$)
If X% > 0 Then GetPrivINI$ = Left$(ret, X%)
End Function

Function GetPrivIniInt% (pApp$, pkey$, pDefault%, pFile$)
GetPrivIniInt% = GetPrivateProfileInt%(pApp$, pkey$, pDefault%, pFile$)
End Function

Function GetSystemDir$ ()
Dim Sys As String * 256, X%
X = GetSystemDirectory(Sys, Len(Sys))
GetSystemDir$ = Left$(Sys, InStr(Sys, Chr$(0)) - 1) + "\"
End Function

Function GetWinINI$ (pApp$, pkey$, pDefault$)
Dim X%
Dim ret As String * 1024
X% = GetProfileString%(pApp$, pkey$, pDefault$, ret, Len(ret))
If X% > 0 Then GetWinINI$ = Left$(ret, X%)
End Function

Function GetWinIniInt% (pApp$, pkey$, pDefault%)
GetWinIniInt% = GetProfileInt%(pApp$, pkey$, pDefault%)
End Function

Function Install% (fName$)
Dim ret As String * 255
Dim Test$, y%
Test$ = GetPrivINI$("fonts", fName$, "uh-oh", "WSFONTS.INI")
If Test$ = "uh-oh" Then MsgBox "can't install " & fName$: Exit Function
y% = AddFontResource(Test$)   '  remove font resource for this file
If y% <> 0 Then
   PutWinIni "fonts", fName$, Test$
   DeletePrivIni "fonts", fName$, "WSFONTS.INI"
Else
   MsgBox "Couldn't install font."
End If
Install% = True
End Function

Function ListPrivateIniEntries$ (pApp$, pFile$)
Dim X%
X% = GetPrivateProfileString%(pApp$, 0&, "", ret, Len(ret), pFile$)
CheckLimits X%
If X% > 0 Then ListPrivateIniEntries$ = Left$(ret, X%)
End Function

Function ListWinIniEntries$ (pApp$)
Dim X%
X% = GetProfileString%(pApp$, 0&, "", ret, Len(ret))
CheckLimits X%
If X% > 0 Then ListWinIniEntries$ = Left$(ret, X%)
End Function

Sub PutPrivIni (pApp$, pkey$, pString$, pFile$)
Dim X%
X% = WritePrivateProfileString%(pApp$, pkey$, pString$, pFile$)
End Sub

Sub PutWinIni (pApp$, pkey$, pString$)
Dim X%
X% = WriteProfileString%(pApp$, pkey$, pString$)
End Sub

Function UninStall% (ByVal fName$)
Dim ret As String * 255
Dim Test$, y%
Test$ = GetWinINI$("fonts", fName$, "uh-oh")
If Test$ = "uh-oh" Then MsgBox "Can't uninstall " & fName$: Exit Function
y% = RemoveFontResource(Test$)   '  remove font resource for this file
PutPrivIni "fonts", fName$, Test$, "WSFONTS.INI"
DeleteWinIni "fonts", fName$
UninStall% = True
End Function

Function UnsignedInt& (AA$)
'   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'   Convert string to unsigned int
'   * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
Dim Value&
Value& = Asc(Right$(AA$, 1)) * 256&
Value& = Value& + Asc(Left$(AA$, 1))
UnsignedInt& = Value&
End Function

